codeunit 50014 DynamicWebExt
{
    EventSubscriberInstance = StaticAutomatic;
    SingleInstance = true;

    // //Sales order interceptor - After
    // [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebOrdersPublisher, 'OnAfterCreateOrderRequest', '', true, true)]
    // procedure OnBeforeSendXmlResponse(var orderNode: XmlNode; var responseRootNode: XmlNode)
    // var
    //     vResponseNodeText: Text;
    // begin
    //     if not MoveCustomerNoForSOResponse(orderNode, responseRootNode) then
    //         log(GetLastErrorText(), GetLastErrorCallStack(), 'OnAfterCreateOrderRequest');

    //     //TODO: remove debug
    //     responseRootNode.WriteTo(vResponseNodeText);
    //     logLongText(vResponseNodeText, 'DEBUG: OnAfterCreateOrderRequest response');
    // end;

    //Sales order calculation interceptor - After
    // [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebOrdersPublisher, 'OnAfterCalculateOrderRequest', '', true, true)]
    // procedure OnAfterCalculateOrderRequest(var orderNode: XmlNode; var responseRootNode: XmlNode)
    // var
    //     vResponseNodeText: Text;
    //     vLogBuilder: TextBuilder;
    // begin
    //     if not moveHandlingAfterOrderCalc(orderNode, responseRootNode) then
    //         log(GetLastErrorText(), GetLastErrorCallStack(), 'OnAfterCalculateOrderRequest');

    //     //TODO: remove debug
    //     orderNode.WriteTo(vResponseNodeText);
    //     vLogBuilder.AppendLine(vResponseNodeText);
    //     Clear(vResponseNodeText);
    //     responseRootNode.WriteTo(vResponseNodeText);
    //     vLogBuilder.AppendLine(vResponseNodeText);
    //     logLongText(vLogBuilder.ToText(), 'DEBUG: OnAfterCalculateOrderRequest response');
    // end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebOrdersPublisher, 'OnAfterAddSalesHeaderToResponse', '', true, true)]
    procedure OnAfterAddSalesHeaderToResponse(var responseSalesHeaderXml: XmlNode; salesheader: Record "Sales Header");
    var
        pNode: XmlNode;
        orderPriceWithVatNode: XmlNode;
        orderPriceWithoutVatNode: XmlNode;
        orderPriceVatNode: XmlNode;
        price: Decimal;
        priceWithVat: Decimal;
        priceWithoutVat: Decimal;
        pCustomer: Record Customer;
        vHandlingCost: Decimal;
        orderPriceWithVat: Decimal;
        orderPriceWithoutVat: Decimal;
        orderPriceVat: Decimal;
        vSalesLine: Record "Sales Line";
        requestDoc: XmlDocument;
        dwShowPricesWithVat: Boolean;
    begin
        requestDoc := DynamicwebContext.GetRequest();
        //
        dwShowPricesWithVat := XmlHelper.GetBoolFromNode(requestDoc.AsXmlNode(),
            '/tables/table[@tableName="EcomOrders"]/item/column[@columnName="ShowPriceWithVat"]');

        pCustomer.Get(salesheader."Sell-to Customer No.");

        responseSalesHeaderXml.SelectSingleNode('//column[@columnName=''OrderPriceWithVat'']', orderPriceWithVatNode);
        if not Evaluate(orderPriceWithVat, orderPriceWithVatNode.AsXmlElement().InnerText()) then
            Error('Could not extract Sales Order Amount Incl. VAT from sales order');

        responseSalesHeaderXml.SelectSingleNode('//column[@columnName=''OrderPriceWithoutVat'']', orderPriceWithoutVatNode);
        if not Evaluate(orderPriceWithoutVat, orderPriceWithoutVatNode.AsXmlElement().InnerText()) then
            Error('Could not extract Sales Order Amount Excl. VAT from sales order');

        responseSalesHeaderXml.SelectSingleNode('//column[@columnName=''OrderPriceVat'']', OrderPriceVatNode);
        if not Evaluate(orderPriceVat, OrderPriceVatNode.AsXmlElement().InnerText()) then
            Error('Could not extract OrderPriceVat from sales order');

        if salesheader."No." <> '' then begin
            //create order            
            vHandlingCost := getHandlingCost(pCustomer, orderPriceWithVat);
        end else begin
            //calculate order
            vHandlingCost := getHandlingCost(pCustomer, orderPriceWithVat);
        end;


        if (salesheader."Prices Including VAT" = true) then begin
            priceWithVat := vHandlingCost;
            priceWithoutVat := ROUND((priceWithVat / (1 + (MaxVATPostingSetupVATPercent / 100))), 0.01, '=');
        end else begin
            priceWithoutVat := vHandlingCost;
            priceWithVat := ROUND((priceWithoutVat * (1 + (MaxVATPostingSetupVATPercent / 100))), 0.01, '=');
        end;

        orderPriceWithVat += priceWithVat;
        orderPriceWithoutVat += priceWithoutVat;


        if salesheader."No." <> '' then begin
            //create order            
            //vHandlingCost := getHandlingCost(pCustomer, orderPriceWithVat);
            vSalesLine.Init();
            vSalesLine."Document Type" := vSalesLine."Document Type"::Order;
            vSalesLine.Type := vSalesLine.Type::"G/L Account";
            vSalesLine."Document No." := salesheader."No.";
            vSalesLine."No." := '1002';
            vSalesLine."Qty. Assigned" := 1;
            if salesHeader."Prices Including VAT" then begin
                vSalesLine."Unit Price" := priceWithVat;
            end else begin
                vSalesLine."Unit Price" := priceWithoutVat;
            end;
            vSalesLine.VALIDATE(Quantity, 1);
            if salesHeader."Prices Including VAT" then begin
                vSalesLine."Line Amount" := priceWithVat;
            end else begin
                vSalesLine."Line Amount" := priceWithoutVat;
            end;
            vSalesLine."VAT Base Amount" := priceWithVat - priceWithoutVat;
            vSalesLine."VAT Difference" := priceWithVat - priceWithoutVat;
            vSalesLine.VALIDATE(Amount, priceWithVat);
            vSalesLine."Amount Including VAT" := priceWithVat;
            vSalesLine."Gen. Bus. Posting Group" := salesHeader."Gen. Bus. Posting Group";
            vSalesLine."VAT Bus. Posting Group" := salesHeader."VAT Bus. Posting Group";
            vSalesLine.Insert();
        end else begin
            //calculate order                        
            //vHandlingCost := getHandlingCost(pCustomer, orderPriceWithVat);
        end;

        AddOrUpdateFieldValue(responseSalesHeaderXml, 'HandlingAmountExc', Format(priceWithoutVat));
        AddOrUpdateFieldValue(responseSalesHeaderXml, 'HandlingAmountInc', Format(priceWithVat));
        AddOrUpdateFieldValue(responseSalesHeaderXml, 'OrderPriceWithoutVat', Format(orderPriceWithoutVat));
        AddOrUpdateFieldValue(responseSalesHeaderXml, 'OrderPriceWithVat', Format(orderPriceWithVat));
        AddOrUpdateFieldValue(responseSalesHeaderXml, 'OrderPriceVat', Format(orderPriceVat + priceWithVat - priceWithoutVat));
        MaxVATPostingSetupVATPercent := 0;
    end;


    //Sales order calculation interceptor - AfterCalc
    // [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebOrdersPublisher, 'OnAfterCalculateOrder', '', true, true)]
    // procedure OnAfterCalculateOrder(var customer: Record Customer; var salesheader: Record "Sales Header"; XMLOrderNode: XmlNode)
    // var
    //     vOrderNode: Text;
    //     vLogBuilder: TextBuilder;
    //     vSinglenOde: XmlNode;
    //     pNode: XmlNode;
    //     price: Decimal;
    // begin

    //     if not addHandlingCostToResponseNode(customer, XMLOrderNode) then
    //         log(GetLastErrorText(), GetLastErrorCallStack(), 'OnAfterCalculateOrder');

    //     //TODO: remove debug
    //     XMLOrderNode.WriteTo(vOrderNode);
    //     vLogBuilder.AppendLine(vOrderNode);
    //     vLogBuilder.AppendLine(customer."No.");
    //     vLogBuilder.AppendLine(Format(salesheader."Amount Including VAT"));
    //     logLongText(vLogBuilder.ToText(), 'DEBUG: OnAfterCalculateOrder xmlOrderNode');
    // end;


    // [TryFunction]
    // local procedure addHandlingCostToResponseNode(pCustomer: Record Customer; var responseSalesHeaderXml: XmlNode)
    // var
    //     vSalesLines: Record "Sales Line";
    //     vSalesLinesText: TextBuilder;
    //     vSaleslineText: Text;
    //     vHandlingCost: Decimal;
    //     vCustomer: Record Customer;
    //     vAmountInclVatNode: XmlNode;
    //     vAmountInclVat: Decimal;
    //     vEcomOrdersNode: XmlNode;
    //     //codGeneral: Codeunit PRD_General;
    //     vVATPercentage: Decimal;
    // begin
    //     responseSalesHeaderXml.SelectSingleNode('//column[@columnName=''OrderPriceTotal'']', vAmountInclVatNode);
    //     if not Evaluate(vAmountInclVat, vAmountInclVatNode.AsXmlElement().InnerText()) then
    //         Error('Could not extract Sales Order Amount Incl. VAT from sales order');

    //     vHandlingCost := getHandlingCost(pCustomer, vAmountInclVat);
    //     responseSalesHeaderXml.SelectSingleNode('//item[@table=''EcomOrders'']', vEcomOrdersNode);

    //     XmlHelper.AddField(vEcomOrdersNode, 'TrueOrderShippingFee', Format(vHandlingCost));
    //     XmlHelper.AddField(vEcomOrdersNode, 'HandlingAmountInc', Format(vHandlingCost));

    //     // if not codGeneral.getHandlingVATPercentage(pCustomer, vVATPercentage) then begin
    //     //     log(GetLastErrorText(), GetLastErrorCallStack(), 'VAT Percentage in order calculation');
    //     //     XmlHelper.AddField(responseSalesHeaderXml, 'HandlingAmountVATPercentage', 'ERROR');
    //     // end else
    //     XmlHelper.AddField(responseSalesHeaderXml, 'HandlingAmountVATPercentage', Format(vVATPercentage));
    // end;


    [TryFunction]
    local procedure moveHandlingAfterOrderCalc(pOrderNode: XmlNode; pResponseNode: XmlNode)
    var
        vSelectedNode: XmlNode;
        vEcomOrdersNode: XmlNode;
    begin
        pResponseNode.SelectSingleNode('//item[@table=''EcomOrders'']', vEcomOrdersNode);
        XmlHelper.AddField(vEcomOrdersNode, 'OrderShippingFee', XmlHelper.GetTextFromNode(pOrderNode, 'column[@columnName=''TrueOrderShippingFee'']'));
        XmlHelper.AddField(vEcomOrdersNode, 'HandlingAmountInc', XmlHelper.GetTextFromNode(pOrderNode, 'column[@columnName=''HandlingAmountInc'']'));
        XmlHelper.AddField(vEcomOrdersNode, 'HandlingAmountVATPercentage', XmlHelper.GetTextFromNode(pOrderNode, 'column[@columnName=''HandlingAmountVATPercentage'']'));
    end;

    [TryFunction]
    local procedure MoveCustomerNoForSOResponse(var requestNode: XmlNode; var responseNode: XmlNode)
    var
        vOrderCustomerNumberNode: XmlNode;
        vOrderShippingFeeNode: XmlNode;
        vCustomerNo: Text;
        vOrderNo: Text;
        vSalesLine: Record "Sales Line";
    begin
        responseNode.SelectSingleNode('/tables/column[@columnName=''OrderCustomerNumber'']', vOrderCustomerNumberNode);
        vCustomerNo := vOrderCustomerNumberNode.AsXmlElement().InnerText();
        vOrderCustomerNumberNode.Remove();

        Clear(vOrderCustomerNumberNode);
        responseNode.SelectSingleNode('/tables/table[@tableName=''EcomOrders'']/item', vOrderCustomerNumberNode);
        XmlHelper.AddField(vOrderCustomerNumberNode, 'OrderCustomerNumber', vCustomerNo);

        if vOrderCustomerNumberNode.SelectSingleNode('//column[@columnName=''OrderShippingFee'']', vOrderShippingFeeNode) then
            vOrderShippingFeeNode.Remove();
        Clear(vOrderShippingFeeNode);

        vOrderNo := XmlHelper.GetTextFromNode(vOrderCustomerNumberNode, 'column[@columnName=''OrderId'']');
        vSalesLine.setRange("Document Type", vSalesLine."Document Type"::Order);
        vSalesLine.SetRange(Type, vSalesLine.Type::"G/L Account");
        vSalesLine.SetRange("Document No.", vOrderNo);
        vSalesLine.SetRange("No.", '705000');
        if vSalesLine.FindFirst() then begin
            XmlHelper.AddField(vOrderCustomerNumberNode, 'OrderShippingFee', Format(vSalesLine."Amount Including VAT"));
            XmlHelper.AddField(vOrderCustomerNumberNode, 'HandlingAmountInc', Format(vSalesLine."Amount Including VAT"));
            XmlHelper.AddField(vOrderCustomerNumberNode, 'HandlingAmountExc', Format(vSalesLine.Amount));
            XmlHelper.AddField(vOrderCustomerNumberNode, 'HandlingAmountVAT', Format((vSalesLine."Amount Including VAT" - vSalesLine.Amount)));
        end else begin
            XmlHelper.AddField(vOrderCustomerNumberNode, 'OrderShippingFee', Format(0));
            XmlHelper.AddField(vOrderCustomerNumberNode, 'HandlingAmountInc', '0');
            XmlHelper.AddField(vOrderCustomerNumberNode, 'HandlingAmountExc', '0');
            XmlHelper.AddField(vOrderCustomerNumberNode, 'HandlingAmountVAT', '0');
        end;
    end;




    local procedure log(pText: Text; pStackTrace: Text; pURL: Text)
    begin
    end;

    local procedure logLongText(pLongText: Text; pTitle: Text)
    begin
    end;


    var
        XmlHelper: Codeunit DynamicwebXmlHelper;
        DynamicwebContext: Codeunit DynamicwebContext;
        MaxVATPostingSetupVATPercent: decimal;

    //Returns handling cost for country, customer type and amount
    // amount > 0  = handling cost
    // 0 = no handling cost
    // -1 = error
    local procedure getHandlingCost(pCustomer: Record Customer; pOrderAmount: Decimal): Decimal
    var
        vCountryRegion: Record "Country/Region";
    begin
        // vCountryRegion.SetRange(Code, pCustomer."Country/Region Code");
        // if not vCountryRegion.FindFirst() then begin
        //     log('Could not find Country with code ' + pCustomer."Country/Region Code", '', 'OnAfterCalculateOrder');
        //     exit(-1);
        // end;

        if pCustomer."Prices Including VAT" then begin
        end else begin
        end;
        exit(100);

        //if pCustomer."Partner Type" = pCustomer."Partner Type"::Person then            
        //if pOrderAmount < vCountryRegion.PRD_NoHandlingFromB2C then
        //exit(vCountryRegion.PRD_HandlingCostB2C)                
        //else
        //    exit(0);
        //if pCustomer."Partner Type" = pCustomer."Partner Type"::Company then            
        //if pOrderAmount < vCountryRegion.PRD_NoHandlingFromB2B then
        //exit(vCountryRegion.PRD_HandlingCostB2B)
        //else
        //exit(0);
        exit(-1);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebOrdersPublisher, 'OnBeforeCalculateSalesLine', '', true, true)]
    procedure OnBeforeCalculateSalesLine(var isHandled: Boolean; var salesline: Record "Sales Line"; var item: Record Item;
        var Currency: Record Currency; var CurrencyFactor: Decimal; var GLSetup: Record "General Ledger Setup"; var uom: Text;
        var QtyPerUOM: Decimal; var useDynamicwebDiscount: Boolean; var customer: Record Customer; var VATPostingSetupVATPercent: decimal; var VATCalcType: Enum "Tax Calculation Type")
    begin
        if MaxVATPostingSetupVATPercent < VATPostingSetupVATPercent then
            MaxVATPostingSetupVATPercent := VATPostingSetupVATPercent;
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebOrdersPublisher, 'CreateOrderOnAfterCreateSalesLine', '', true, true)]
    procedure CreateOrderOnAfterCreateSalesLine(var salesline: Record "Sales Line"; var salesheader: Record "Sales Header"; requestDoc: XmlDocument; var requestOrderNode: XmlNode; var requestOrderLineNode: XmlNode;
        var useDynamicwebDiscount: Boolean);
    var
        VATPostingSetup: Record "VAT Posting Setup";
        pCustomer: Record Customer;
        item: Record Item;
    begin
        pCustomer.Get(salesheader."Sell-to Customer No.");
        item.Get(salesline."No.");
        VATPostingSetup.GET(pCustomer."VAT Bus. Posting Group", item."VAT Prod. Posting Group");
        if MaxVATPostingSetupVATPercent < VATPostingSetup."VAT %" then
            MaxVATPostingSetupVATPercent := VATPostingSetup."VAT %";
    end;

    procedure AddOrUpdateFieldValue(var parentXmlNode: XmlNode; childColumnName: Text; childColumnValue: Text): XmlNode
    var
        pNode: XmlNode;
    begin
        if parentXmlNode.SelectSingleNode('column[@columnName=''' + childColumnName + ''']', pNode)
        then
            UpdateField(pNode, childColumnName, childColumnValue)
        else
            pNode := XmlHelper.AddColumnField(parentXmlNode, ReplaceInvalidXMLCharacters(childColumnName), childColumnValue);
        exit(pNode);
    end;

    procedure UpdateField(var columnNode: XmlNode; columnName: Text; columnValue: Text)
    var
        pNode: XmlNode;
    begin
        pNode := XmlElement.Create('column', '', XmlCData.Create(columnValue)).AsXmlNode();
        pNode.AsXmlElement().SetAttribute('columnName', ReplaceInvalidXMLCharacters(columnName));
        columnNode.ReplaceWith(pNode);
    end;

    procedure ReplaceInvalidXMLCharacters(pText: Text): Text
    var
        lText: Text;
    begin
        lText := pText;
        lText := lText.Replace('&', '&amp;');
        lText := lText.Replace('<', '&lt;');
        lText := lText.Replace('>', '&gt;');
        lText := lText.Replace('"', '&quot;');
        lText := lText.Replace('''', '&apos;');
        exit(lText);
    end;
}